/* @flow */

"use strict";

var _interopRequireDefault = require("babel-runtime/helpers/interop-require-default")["default"];

var _interopRequireWildcard = require("babel-runtime/helpers/interop-require-wildcard")["default"];

exports.__esModule = true;

var _babelHelperFunctionName = require("babel-helper-function-name");

var _babelHelperFunctionName2 = _interopRequireDefault(_babelHelperFunctionName);

var _babelTypes = require("babel-types");

var t = _interopRequireWildcard(_babelTypes);

/*:: import type { NodePath } from "babel-traverse";*/

var awaitVisitor = {
  Function: function Function(path) {
    path.skip();
  },

  AwaitExpression: function AwaitExpression(_ref) {
    var node = _ref.node;

    node.type = "YieldExpression";
  }
};

exports["default"] = function (path /*: NodePath*/, callId /*: Object*/) {
  var node = path.node;
  if (node.generator) return;

  if (path.isClassMethod()) {
    node.async = false;

    var body = node.body;

    var _container = t.functionExpression(null, [], t.blockStatement(body.body), true);
    _container.shadow = true;
    body.body = [t.returnStatement(t.callExpression(t.callExpression(callId, [_container]), []))];
    return;
  }

  node.async = false;
  node.generator = true;

  path.traverse(awaitVisitor);

  var container = t.functionExpression(null, [], t.blockStatement([t.returnStatement(t.callExpression(t.callExpression(callId, [node]), []))]));
  node.shadow = container;

  if (path.isFunctionDeclaration()) {
    var declar = t.variableDeclaration("let", [t.variableDeclarator(t.identifier(node.id.name), container)]);
    declar._blockHoist = true;

    _babelHelperFunctionName2["default"]({
      node: container,
      parent: declar.declarations[0],
      scope: path.scope
    });

    path.replaceWith(declar);
  } else {
    path.replaceWith(container);
  }
};

module.exports = exports["default"];